diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/netanim/bindings/modulegen__gcc_LP64.py ns-3.35/src/netanim/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/netanim/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/netanim/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
@@ -16321,10 +16343,10 @@
                    'ns3::PhyEntity::PhyFieldRxStatus', 
                    [param('ns3::Ptr< ns3::Event >', 'event')], 
                    is_virtual=True, visibility='protected')
-    ## phy-entity.h (module 'wifi'): ns3::Ptr<ns3::Event> ns3::PhyEntity::DoGetEvent(ns3::Ptr<const ns3::WifiPpdu> ppdu, ns3::RxPowerWattPerChannelBand rxPowersW) [member function]
+    ## phy-entity.h (module 'wifi'): ns3::Ptr<ns3::Event> ns3::PhyEntity::DoGetEvent(ns3::Ptr<const ns3::WifiPpdu> ppdu, ns3::RxPowerWattPerChannelBand & rxPowersW) [member function]
     cls.add_method('DoGetEvent', 
                    'ns3::Ptr< ns3::Event >', 
-                   [param('ns3::Ptr< ns3::WifiPpdu const >', 'ppdu'), param('std::map< std::pair< unsigned int, unsigned int >, double >', 'rxPowersW')], 
+                   [param('ns3::Ptr< ns3::WifiPpdu const >', 'ppdu'), param('ns3::RxPowerWattPerChannelBand &', 'rxPowersW')], 
                    is_virtual=True, visibility='protected')
     ## phy-entity.h (module 'wifi'): void ns3::PhyEntity::DoResetReceive(ns3::Ptr<ns3::Event> event) [member function]
     cls.add_method('DoResetReceive', 
@@ -16451,10 +16473,10 @@
                    'void', 
                    [param('ns3::Ptr< ns3::Event >', 'event')], 
                    visibility='protected')
-    ## phy-entity.h (module 'wifi'): void ns3::PhyEntity::UpdateInterferenceEvent(ns3::Ptr<ns3::Event> event, ns3::RxPowerWattPerChannelBand rxPower) [member function]
+    ## phy-entity.h (module 'wifi'): void ns3::PhyEntity::UpdateInterferenceEvent(ns3::Ptr<ns3::Event> event, ns3::RxPowerWattPerChannelBand const & rxPower) [member function]
     cls.add_method('UpdateInterferenceEvent', 
                    'void', 
-                   [param('ns3::Ptr< ns3::Event >', 'event'), param('std::map< std::pair< unsigned int, unsigned int >, double >', 'rxPower')], 
+                   [param('ns3::Ptr< ns3::Event >', 'event'), param('ns3::RxPowerWattPerChannelBand const &', 'rxPower')], 
                    visibility='protected')
     return
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/network/bindings/modulegen__gcc_ILP32.py ns-3.35/src/network/bindings/modulegen__gcc_ILP32.py
--- ns-3.34/src/network/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/network/bindings/modulegen__gcc_ILP32.py	2021-10-01 13:26:47.000000000 -0700
@@ -2426,11 +2426,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -2535,11 +2530,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -2656,11 +2646,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -2853,11 +2838,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/network/bindings/modulegen__gcc_LP64.py ns-3.35/src/network/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/network/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/network/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
@@ -2426,11 +2426,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -2535,11 +2530,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -2656,11 +2646,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -2853,11 +2838,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/network/model/buffer.cc ns-3.35/src/network/model/buffer.cc
--- ns-3.34/src/network/model/buffer.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/network/model/buffer.cc	2021-10-01 13:26:47.000000000 -0700
@@ -400,8 +400,9 @@
 Buffer::AddAtEnd (const Buffer &o)
 {
   NS_LOG_FUNCTION (this << &o);
+
   if (m_data->m_count == 1 &&
-      m_end == m_zeroAreaEnd &&
+      (m_end == m_zeroAreaEnd || m_zeroAreaStart == m_zeroAreaEnd) &&
       m_end == m_data->m_dirtyEnd &&
       o.m_start == o.m_zeroAreaStart &&
       o.m_zeroAreaEnd - o.m_zeroAreaStart > 0)
@@ -411,8 +412,12 @@
        * we attempt to aggregate two buffers which contain
        * adjacent zero areas.
        */
+      if (m_zeroAreaStart == m_zeroAreaEnd)
+        {
+          m_zeroAreaStart = m_end;
+        }
       uint32_t zeroSize = o.m_zeroAreaEnd - o.m_zeroAreaStart;
-      m_zeroAreaEnd += zeroSize;
+      m_zeroAreaEnd = m_end + zeroSize;
       m_end = m_zeroAreaEnd;
       m_data->m_dirtyEnd = m_zeroAreaEnd;
       uint32_t endData = o.m_end - o.m_zeroAreaEnd;
@@ -812,14 +817,10 @@
 Buffer::Iterator::CheckNoZero (uint32_t start, uint32_t end) const
 {
   NS_LOG_FUNCTION (this << &start << &end);
-  for (uint32_t i = start; i < end; i++)
-    {
-      if (!Check (i))
-        {
-          return false;
-        }
-    }
-  return true;
+  return !(start < m_dataStart ||
+           end > m_dataEnd ||
+           (end > m_zeroStart && start < m_zeroEnd && m_zeroEnd != m_zeroStart && start != end)
+           );
 }
 bool 
 Buffer::Iterator::Check (uint32_t i) const
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/network/utils/ipv4-address.cc ns-3.35/src/network/utils/ipv4-address.cc
--- ns-3.34/src/network/utils/ipv4-address.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/network/utils/ipv4-address.cc	2021-10-01 13:26:47.000000000 -0700
@@ -110,17 +110,6 @@
 }
 
 bool 
-Ipv4Mask::IsEqual (Ipv4Mask other) const
-{
-  NS_LOG_FUNCTION (this << other);
-  if (other.m_mask == m_mask) {
-      return true;
-    } else {
-      return false;
-    }
-}
-
-bool 
 Ipv4Mask::IsMatch (Ipv4Address a, Ipv4Address b) const
 {
   NS_LOG_FUNCTION (this << a << b);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/network/utils/ipv4-address.h ns-3.35/src/network/utils/ipv4-address.h
--- ns-3.34/src/network/utils/ipv4-address.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/network/utils/ipv4-address.h	2021-10-01 13:26:47.000000000 -0700
@@ -77,19 +77,6 @@
     */
   void Set (char const *address);
   /**
-   * \brief Comparison operation between two Ipv4Addresses
-   *
-   * \deprecated Use the == operator (same functionality)
-   *
-   * \param other address to which to compare this address
-   * \return True if the addresses are equal. False otherwise.
-   */
-  NS_DEPRECATED_3_31
-  bool IsEqual (const Ipv4Address &other) const
-  {
-    return m_address == other.m_address;
-  }
-  /**
    * Serialize this address to a 4-byte buffer
    *
    * \param buf output buffer to which this address gets overwritten with this
@@ -289,15 +276,6 @@
    * corresponding to this mask
    */
   bool IsMatch (Ipv4Address a, Ipv4Address b) const;
-  /**
-   *
-   * \deprecated Use the == operator (same functionality)
-   *
-   * \param other a mask to compare 
-   * \return true if the mask equals the mask passed as input parameter
-   */
-  NS_DEPRECATED_3_31
-  bool IsEqual (Ipv4Mask other) const;
   /** 
    * Get the host-order 32-bit IP mask
    * \return the host-order 32-bit IP mask
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/network/utils/ipv6-address.cc ns-3.35/src/network/utils/ipv6-address.cc
--- ns-3.34/src/network/utils/ipv6-address.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/network/utils/ipv6-address.cc	2021-10-01 13:26:47.000000000 -0700
@@ -925,16 +925,6 @@
   return false;
 }
 
-bool Ipv6Address::IsEqual (const Ipv6Address& other) const
-{
-  NS_LOG_FUNCTION (this << other);
-  if (!memcmp (m_address, other.m_address, 16))
-    {
-      return true;
-    }
-  return false;
-}
-
 bool Ipv6Address::IsInitialized (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -1156,15 +1146,6 @@
   return 128 - prefixLength;
 }
 
-bool Ipv6Prefix::IsEqual (const Ipv6Prefix& other) const
-{
-  if (!memcmp (m_prefix, other.m_prefix, 16))
-    {
-      return true;
-    }
-  return false;
-}
-
 std::ostream& operator << (std::ostream& os, Ipv6Prefix const& prefix)
 {
   prefix.Print (os);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/network/utils/ipv6-address.h ns-3.35/src/network/utils/ipv6-address.h
--- ns-3.34/src/network/utils/ipv6-address.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/network/utils/ipv6-address.h	2021-10-01 13:26:47.000000000 -0700
@@ -99,17 +99,6 @@
   void Set (uint8_t address[16]);
 
   /**
-   * \brief Comparison operation between two Ipv6Addresses.
-   *
-   * \deprecated Use the == operator (same functionality)
-   *
-   * \param other the IPv6 address to which to compare this address
-   * \return true if the addresses are equal, false otherwise
-   */
-  NS_DEPRECATED_3_31
-  bool IsEqual (const Ipv6Address& other) const;
-
-  /**
    * \brief Serialize this address to a 16-byte buffer.
    * \param buf the output buffer to which this address gets overwritten with this
    * Ipv6Address
@@ -568,17 +557,6 @@
   uint8_t GetMinimumPrefixLength () const;
 
   /**
-   * \brief Comparison operation between two Ipv6Prefix.
-   *
-   * \deprecated Use the == operator (same functionality)
-   *
-   * \param other the IPv6 prefix to which to compare this prefix
-   * \return true if the prefixes are equal, false otherwise
-   */
-  NS_DEPRECATED_3_31
-  bool IsEqual (const Ipv6Prefix& other) const;
-
-  /**
    * \brief Print this address to the given output stream.
    *
    * The print format is in the typical "2001:660:4701::1".
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/network/utils/pcap-file-wrapper.cc ns-3.35/src/network/utils/pcap-file-wrapper.cc
--- ns-3.34/src/network/utils/pcap-file-wrapper.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/network/utils/pcap-file-wrapper.cc	2021-10-01 13:26:47.000000000 -0700
@@ -184,10 +184,9 @@
   uint32_t origLen;
   uint32_t readLen;
 
-  uint32_t maxBytes=65536;
-  uint8_t  datbuf[maxBytes];
+  uint8_t  datbuf[65536];
 
-  m_file.Read (datbuf,maxBytes,tsSec,tsUsec,inclLen,origLen,readLen);
+  m_file.Read (datbuf,65536,tsSec,tsUsec,inclLen,origLen,readLen);
 
   if (m_file.Fail())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/network/utils/sequence-number.h ns-3.35/src/network/utils/sequence-number.h
--- ns-3.34/src/network/utils/sequence-number.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/network/utils/sequence-number.h	2021-10-01 13:26:47.000000000 -0700
@@ -151,7 +151,7 @@
 
    /**
    * \brief Postfix decrement operator
-   * \returns incremented sequence number
+   * \returns decremented sequence number
    */ 
   SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE> operator-- (int)
   {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/nix-vector-routing/bindings/callbacks_list.py ns-3.35/src/nix-vector-routing/bindings/callbacks_list.py
--- ns-3.34/src/nix-vector-routing/bindings/callbacks_list.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/nix-vector-routing/bindings/callbacks_list.py	2021-10-01 13:26:47.000000000 -0700
@@ -8,4 +8,10 @@
     ['void', 'ns3::Ptr<ns3::Socket>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'const ns3::Address &', 'ns3::NetDevice::PacketType', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'const ns3::Ipv4Header &', 'ns3::Ptr<const ns3::Packet>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ptr<ns3::Ipv4>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'const ns3::Ipv4Header &', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ipv4L3Protocol::DropReason', 'ns3::Ptr<ns3::Ipv4>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ptr<ns3::Ipv6>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'const ns3::Ipv6Header &', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ipv6L3Protocol::DropReason', 'ns3::Ptr<ns3::Ipv6>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'const ns3::Ipv6Header &', 'ns3::Ptr<const ns3::Packet>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
 ]
